diff -wrubN quake3_1.32b/code/client/cl_main.c dfengine_1.07_src/code/client/cl_main.c
--- quake3_1.32b/code/client/cl_main.c	2009-04-18 19:32:30.000000000 +0200
+++ dfengine_1.07_src/code/client/cl_main.c	2009-04-18 19:37:40.000000000 +0200
@@ -500,12 +500,13 @@
 	char		retry[MAX_OSPATH];
 
 	if (Cmd_Argc() != 2) {
-		Com_Printf ("playdemo <demoname>\n");
+		Com_Printf ("usage: demo <demoname>\n");
 		return;
 	}
 
 	// make sure a local server is killed
 	Cvar_Set( "sv_killserver", "1" );
+	SV_Frame(0);	// Cgg - kill it now
 
 	CL_Disconnect( qtrue );
 
@@ -1973,7 +1974,7 @@
 */
 void CL_CheckUserinfo( void ) {
 	// don't add reliable commands when not yet connected
-	if ( cls.state < CA_CHALLENGING ) {
+	if ( cls.state < CA_CONNECTED && cls.state != CA_CINEMATIC ) {	// Cgg - was < CA_CHALLENGING 
 		return;
 	}
 	// don't overflow the reliable command buffer when paused
@@ -2279,7 +2280,10 @@
 	// register our variables
 	//
 	cl_noprint = Cvar_Get( "cl_noprint", "0", 0 );
-	cl_motd = Cvar_Get ("cl_motd", "1", 0);
+	cl_motd = Cvar_Get ("cl_motd", "0", 0);	// Cgg - global q3 motd
+											// Id's server replies with icmp "port unreachable".
+											// Making it disabled by default - saves a dns query, 
+											// an udp packet + the resulting icmp message.
 
 	cl_timeout = Cvar_Get ("cl_timeout", "200", 0);
 
@@ -2396,6 +2400,8 @@
 
 	SCR_Init ();
 
+	DL_Init();	// Cgg - client download
+
 	Cbuf_Execute ();
 
 	Cvar_Set( "cl_running", "1" );
@@ -2448,6 +2454,8 @@
 	Cmd_RemoveCommand ("showip");
 	Cmd_RemoveCommand ("model");
 
+	DL_Shutdown();	// Cgg
+	
 	Cvar_Set( "cl_running", "0" );
 
 	recursive = qfalse;
@@ -3320,5 +3328,3 @@
 
 	return qfalse;
 }
-
-
diff -wrubN quake3_1.32b/code/client/cl_parse.c dfengine_1.07_src/code/client/cl_parse.c
--- quake3_1.32b/code/client/cl_parse.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/client/cl_parse.c	2009-04-18 19:33:06.000000000 +0200
@@ -255,6 +255,16 @@
 
 	// read areamask
 	len = MSG_ReadByte( msg );
+	// Cgg - ioquake3 rev 796
+	// Fix remotely exploitable parse download overflow reported by Luigi Auriemma.
+	// See http://lists.grok.org.uk/pipermail/full-disclosure/2006-June/046578.html
+	// for the advisory.
+	if(len > sizeof(newSnap.areamask))
+	{
+		Com_Error (ERR_DROP,"CL_ParseSnapshot: Invalid size %d for areamask.", len);
+		return;
+	}
+	// !Cgg
 	MSG_ReadData( msg, &newSnap.areamask, len);
 
 	// read playerinfo
@@ -475,6 +485,17 @@
 	unsigned char data[MAX_MSGLEN];
 	int block;
 
+	// Cgg - ioquake3 rev 796
+	// Fix remotely exploitable parse download overflow reported by Luigi Auriemma.
+	// See http://lists.grok.org.uk/pipermail/full-disclosure/2006-June/046578.html
+	// for the advisory.
+	if (!*clc.downloadTempName) {
+		Com_Printf("Server sending download, but no download was requested\n");
+		CL_AddReliableCommand( "stopdl" );
+		return;
+	}
+	// !Cgg
+
 	// read the data
 	block = MSG_ReadShort ( msg );
 
@@ -493,8 +514,17 @@
 	}
 
 	size = MSG_ReadShort ( msg );
-	if (size > 0)
+	// Cgg - ioquake3 rev 796
+	// Fix remotely exploitable parse download overflow reported by Luigi Auriemma.
+	// See http://lists.grok.org.uk/pipermail/full-disclosure/2006-June/046578.html
+	// for the advisory.
+	if (size < 0 || size > sizeof(data))
+	{
+		Com_Error(ERR_DROP, "CL_ParseDownload: Invalid size %d for download chunk.", size);
+		return;
+	}
 		MSG_ReadData( msg, data, size );
+	// !Cgg
 
 	if (clc.downloadBlock != block) {
 		Com_DPrintf( "CL_ParseDownload: Expected block %d, got %d\n", clc.downloadBlock, block);
@@ -504,11 +534,17 @@
 	// open the file if not opened yet
 	if (!clc.download)
 	{
+		// Cgg - ioquake3 rev 796
+		// Fix remotely exploitable parse download overflow reported by Luigi Auriemma.
+		// See http://lists.grok.org.uk/pipermail/full-disclosure/2006-June/046578.html
+		// for the advisory.
+	/*
 		if (!*clc.downloadTempName) {
 			Com_Printf("Server sending download, but no download was requested\n");
 			CL_AddReliableCommand( "stopdl" );
 			return;
-		}
+		}*/
+		// !Cgg
 
 		clc.download = FS_SV_FOpenFileWrite( clc.downloadTempName );
 
diff -wrubN quake3_1.32b/code/client/cl_scrn.c dfengine_1.07_src/code/client/cl_scrn.c
--- quake3_1.32b/code/client/cl_scrn.c	2009-04-18 19:32:30.000000000 +0200
+++ dfengine_1.07_src/code/client/cl_scrn.c	2009-04-18 19:35:58.000000000 +0200
@@ -30,7 +30,7 @@
 cvar_t		*cl_graphheight;
 cvar_t		*cl_graphscale;
 cvar_t		*cl_graphshift;
-cvar_t		*cl_showRecording;	// Cgg
+cvar_t		*ch_recordMessage;	// Cgg
 
 /*
 ================
@@ -213,6 +213,11 @@
 			s += 2;
 			continue;
 		}
+		// Cgg - repeated escape codes (^^) were broken
+		if (*s == Q_COLOR_ESCAPE && *(s+1) == Q_COLOR_ESCAPE) {
+			s++;
+		}
+		// !Cgg
 		SCR_DrawChar( xx+2, y+2, size, *s );
 		xx += size;
 		s++;
@@ -233,6 +238,11 @@
 			s += 2;
 			continue;
 		}
+		// Cgg - repeated escape codes (^^) were broken
+		if (*s == Q_COLOR_ESCAPE && *(s+1) == Q_COLOR_ESCAPE) {
+			s++;
+		}
+		// !Cgg
 		SCR_DrawChar( xx, y, size, *s );
 		xx += size;
 		s++;
@@ -264,7 +274,8 @@
 Coordinates are at 640 by 480 virtual resolution
 ==================
 */
-void SCR_DrawSmallStringExt( int x, int y, const char *string, float *setColor, qboolean forceColor ) {
+// Cgg - added rawmode: stops color sequences from being interpreted
+void SCR_DrawSmallStringExt( int x, int y, const char *string, float *setColor, qboolean forceColor, qboolean rawmode ) {
 	vec4_t		color;
 	const char	*s;
 	int			xx;
@@ -274,7 +285,7 @@
 	xx = x;
 	re.SetColor( setColor );
 	while ( *s ) {
-		if ( Q_IsColorString( s ) ) {
+		if ( !rawmode && Q_IsColorString( s ) ) {
 			if ( !forceColor ) {
 				Com_Memcpy( color, g_color_table[ColorIndex(*(s+1))], sizeof( color ) );
 				color[3] = setColor[3];
@@ -283,6 +294,11 @@
 			s += 2;
 			continue;
 		}
+		// Cgg - repeated escape codes (^^) failed
+		if (!rawmode && *s == Q_COLOR_ESCAPE && *(s+1) == Q_COLOR_ESCAPE) {
+			s++;
+		}
+		// !Cgg
 		SCR_DrawSmallChar( xx, y, *s );
 		xx += SMALLCHAR_WIDTH;
 		s++;
@@ -302,10 +318,15 @@
 	while ( *s ) {
 		if ( Q_IsColorString( s ) ) {
 			s += 2;
-		} else {
-			count++;
+			continue;
+		}
+		// Cgg - repeated escape codes (^^) were broken
+		if (*s == Q_COLOR_ESCAPE && *(s+1) == Q_COLOR_ESCAPE) {
 			s++;
 		}
+		// !Cgg
+		count++;
+		s++;
 	}
 
 	return count;
@@ -331,7 +352,7 @@
 	int		pos;
 
 	// Cgg - off by default
-	if (!cl_showRecording->integer) {
+	if (!ch_recordMessage->integer) {
 		return;
 	}
 	// !Cgg
@@ -428,7 +449,7 @@
 	cl_graphheight = Cvar_Get ("graphheight", "32", CVAR_CHEAT);
 	cl_graphscale = Cvar_Get ("graphscale", "1", CVAR_CHEAT);
 	cl_graphshift = Cvar_Get ("graphshift", "0", CVAR_CHEAT);
-	cl_showRecording = Cvar_Get ("cl_showRecording", "0", CVAR_ARCHIVE);	// Cgg
+	ch_recordMessage = Cvar_Get ("ch_recordMessage", "0", CVAR_ARCHIVE);	// Cgg
 
 	scr_initialized = qtrue;
 }
diff -wrubN quake3_1.32b/code/client/snd_dma.c dfengine_1.07_src/code/client/snd_dma.c
--- quake3_1.32b/code/client/snd_dma.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/client/snd_dma.c	2009-05-26 12:06:05.000000000 +0200
@@ -181,7 +181,9 @@
 
 		S_StopAllSounds ();
 
-		S_SoundInfo_f();
+		// Cgg - spammy
+		//S_SoundInfo_f();
+		// !Cgg
 	}
 
 }
diff -wrubN quake3_1.32b/code/game/q_math.c dfengine_1.07_src/code/game/q_math.c
--- quake3_1.32b/code/game/q_math.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/game/q_math.c	2009-04-18 19:35:58.000000000 +0200
@@ -36,11 +36,12 @@
 vec4_t		colorMagenta= {1, 0, 1, 1};
 vec4_t		colorCyan	= {0, 1, 1, 1};
 vec4_t		colorWhite	= {1, 1, 1, 1};
+vec4_t		colorOrange	= {1, 0.5, 0, 1};
 vec4_t		colorLtGrey	= {0.75, 0.75, 0.75, 1};
 vec4_t		colorMdGrey	= {0.5, 0.5, 0.5, 1};
 vec4_t		colorDkGrey	= {0.25, 0.25, 0.25, 1};
 
-vec4_t	g_color_table[8] =
+vec4_t	g_color_table[10] =
 	{
 	{0.0, 0.0, 0.0, 1.0},
 	{1.0, 0.0, 0.0, 1.0},
@@ -50,6 +51,8 @@
 	{0.0, 1.0, 1.0, 1.0},
 	{1.0, 0.0, 1.0, 1.0},
 	{1.0, 1.0, 1.0, 1.0},
+	{1.0, 0.5, 0.0, 1.0},
+	{0.5, 0.5, 0.5, 1.0}
 	};
 
 
diff -wrubN quake3_1.32b/code/game/q_shared.c dfengine_1.07_src/code/game/q_shared.c
--- quake3_1.32b/code/game/q_shared.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/game/q_shared.c	2009-04-18 19:35:58.000000000 +0200
@@ -837,6 +837,11 @@
 			p += 2;
 			continue;
 		}
+		// Cgg - repeated escape codes (^^) were broken
+		if (*p == Q_COLOR_ESCAPE && *(p+1) == Q_COLOR_ESCAPE) {
+			p++;
+		}
+		// !Cgg
 		p++;
 		len++;
 	}
@@ -848,20 +853,25 @@
 char *Q_CleanStr( char *string ) {
 	char*	d;
 	char*	s;
-	int		c;
 
 	s = string;
 	d = string;
-	while ((c = *s) != 0 ) {
+	// Cgg - repeated escape codes (^^) were broken
+	while (*s) {
 		if ( Q_IsColorString( s ) ) {
+			s += 2;
+			continue;
+		}
+		if (*s == Q_COLOR_ESCAPE && *(s+1) == Q_COLOR_ESCAPE) {
 			s++;
 		}		
-		else if ( c >= 0x20 && c <= 0x7E ) {
-			*d++ = c;
+		if (*s >= 0x20 && *s <= 0x7E) {
+			*d++ = *s;
 		}
 		s++;
 	}
 	*d = '\0';
+	// !Cgg
 
 	return string;
 }
diff -wrubN quake3_1.32b/code/game/q_shared.h dfengine_1.07_src/code/game/q_shared.h
--- quake3_1.32b/code/game/q_shared.h	2009-04-18 19:32:30.000000000 +0200
+++ dfengine_1.07_src/code/game/q_shared.h	2009-06-08 21:12:45.000000000 +0200
@@ -26,8 +26,11 @@
 // q_shared.h -- included first by ALL program modules.
 // A user mod should never modify this file
 
-#define	Q3_VERSION		"Q3 1.32b"
+// Cgg
+#define	Q3_VERSION		"dfengine 1.07"
 // 1.32 released 7-10-2002
+#define Q3_WINDOW_TITLE Q3_VERSION
+// !Cgg
 
 #define MAX_TEAMNAME 32
 
@@ -54,7 +57,13 @@
 #pragma warning(disable : 4702)		// unreachable code
 #pragma warning(disable : 4711)		// selected for automatic inline expansion
 #pragma warning(disable : 4220)		// varargs matches remaining parameters
-#define _CRT_SECURE_NO_WARNINGS 1	// Cgg - disabling deprecated warnings in crt functions with msvc 2008
+// Cgg - disable various recent msvc warnings regarding "deprecated" C library functions.
+// Complying with this would impede the code portability either way.
+// Besides quake for the most part provides its own "secure" implementation of libc functions.
+#define _CRT_SECURE_NO_WARNINGS 1
+#define _CRT_SECURE_NO_DEPRECATE 1
+#pragma warning(disable : 4996)
+// !Cgg
 #endif
 
 /**********************************************************************
@@ -160,6 +169,9 @@
 
 #define	PATH_SEP '\\'
 
+// Cgg - portability
+#define strncasecmp strnicmp
+
 #endif
 
 //======================= MAC OS X DEFINES =====================
@@ -526,6 +538,7 @@
 extern	vec4_t		colorMagenta;
 extern	vec4_t		colorCyan;
 extern	vec4_t		colorWhite;
+extern	vec4_t		colorOrange;
 extern	vec4_t		colorLtGrey;
 extern	vec4_t		colorMdGrey;
 extern	vec4_t		colorDkGrey;
@@ -541,7 +554,9 @@
 #define COLOR_CYAN		'5'
 #define COLOR_MAGENTA	'6'
 #define COLOR_WHITE		'7'
-#define ColorIndex(c)	( ( (c) - '0' ) & 7 )
+#define COLOR_ORANGE	'8'
+#define COLOR_MDGREY	'9'
+#define ColorIndex(c)	( ( ( (c) - '0' ) &15 ) %10 )
 
 #define S_COLOR_BLACK	"^0"
 #define S_COLOR_RED		"^1"
@@ -551,8 +566,10 @@
 #define S_COLOR_CYAN	"^5"
 #define S_COLOR_MAGENTA	"^6"
 #define S_COLOR_WHITE	"^7"
+#define S_COLOR_ORANGE	"^8"
+#define S_COLOR_MDGREY	"^9"
 
-extern vec4_t	g_color_table[8];
+extern vec4_t	g_color_table[10];
 
 #define	MAKERGB( v, r, g, b ) v[0]=r;v[1]=g;v[2]=b
 #define	MAKERGBA( v, r, g, b, a ) v[0]=r;v[1]=g;v[2]=b;v[3]=a
diff -wrubN quake3_1.32b/code/qcommon/cmd.c dfengine_1.07_src/code/qcommon/cmd.c
--- quake3_1.32b/code/qcommon/cmd.c	2009-04-18 19:32:30.000000000 +0200
+++ dfengine_1.07_src/code/qcommon/cmd.c	2009-04-18 19:34:04.000000000 +0200
@@ -24,7 +24,10 @@
 #include "../game/q_shared.h"
 #include "qcommon.h"
 
-#define	MAX_CMD_BUFFER	16384
+// Cgg - expanding command buffer from 16k to 64k
+//#define	MAX_CMD_BUFFER	16384
+#define	MAX_CMD_BUFFER	0x10000
+// !Cgg
 #define	MAX_CMD_LINE	1024
 
 typedef struct {
@@ -240,7 +243,6 @@
 	char	*f;
 	int		len;
 	char	filename[MAX_QPATH];
-	char	*c, *lf, *s;	// Cgg
 
 	if (Cmd_Argc () != 2) {
 		Com_Printf ("exec <filename> : execute a script file\n");
@@ -256,23 +258,7 @@
 	}
 	Com_Printf ("execing %s\n",Cmd_Argv(1));
 
-	// Cgg - execute the file buffer incrementally
-	Cbuf_Execute();
-	for (c=f,s=f,lf=f; *c; c++) {
-		if (*c == '\n') {
-			lf = c;
-		}
-		if (c - s >= 0x4000 -1) {
-			*lf = 0;
-			Cbuf_InsertText(s);
-			Cbuf_Execute();
-			s = lf+1;
-		}
-	}
-	Cbuf_InsertText(s);
-	Cbuf_Execute();
-	//was: Cbuf_InsertText (f);
-	// !Cgg
+	Cbuf_InsertText (f);
 
 	FS_FreeFile (f);
 }
diff -wrubN quake3_1.32b/code/qcommon/common.c dfengine_1.07_src/code/qcommon/common.c
--- quake3_1.32b/code/qcommon/common.c	2009-04-18 19:32:30.000000000 +0200
+++ dfengine_1.07_src/code/qcommon/common.c	2009-04-18 19:35:58.000000000 +0200
@@ -45,8 +45,8 @@
 #define DEF_COMHUNKMEGS "64"
 #define DEF_COMZONEMEGS "24"
 #else
-#define DEF_COMHUNKMEGS "56"
-#define DEF_COMZONEMEGS "16"
+#define DEF_COMHUNKMEGS "64"	// Cgg: was 56
+#define DEF_COMZONEMEGS "24"	// Cgg: was 16
 #endif
 
 int		com_argc;
@@ -1387,7 +1387,8 @@
 void Com_InitZoneMemory( void ) {
 	cvar_t	*cv;
 	// allocate the random block zone
-	cv = Cvar_Get( "com_zoneMegs", DEF_COMZONEMEGS, CVAR_LATCH | CVAR_ARCHIVE );
+	Com_StartupVariable("com_zoneMegs");	// Cgg: config files and command line options haven't been taken in account yet
+	cv = Cvar_Get( "com_zoneMegs", DEF_COMZONEMEGS, CVAR_LATCH );	// Cgg: was CVAR_ARCHIVE. Does not have meaning as this cvar can only be set through the command line
 
 	if ( cv->integer < 20 ) {
 		s_zoneTotal = 1024 * 1024 * 16;
@@ -3209,11 +3210,14 @@
 	}
 
 	// cut shortestMatch to the amount common with s
-	for ( i = 0 ; s[i] ; i++ ) {
+	// Cgg - was wrong when s had fewer chars than shortestMatch
+	i = 0;
+	do {
 		if ( tolower(shortestMatch[i]) != tolower(s[i]) ) {
 			shortestMatch[i] = 0;
 		}
-	}
+	} while (s[i++]);
+	// !Cgg
 }
 
 /*
diff -wrubN quake3_1.32b/code/qcommon/files.c dfengine_1.07_src/code/qcommon/files.c
--- quake3_1.32b/code/qcommon/files.c	2009-04-18 19:32:30.000000000 +0200
+++ dfengine_1.07_src/code/qcommon/files.c	2009-04-18 19:37:40.000000000 +0200
@@ -565,8 +565,9 @@
 
 ===========
 */
-static void FS_Remove( const char *osPath ) {
-	remove( osPath );
+// Cgg - returns qboolean
+static qboolean FS_Remove( const char *osPath ) {
+	return !remove( osPath );
 }
 
 /*
@@ -2511,8 +2512,40 @@
 	}
 	FS_FreeFileList(matches);
 
-	// demos
-	matches = FS_ListFilteredFiles(searchpath, ".dm_6?", NULL, &n);
+	// .dm_68
+	matches = FS_ListFilteredFiles(searchpath, ".dm_68", NULL, &n);
+	for (i=0; i<n; i++) {
+		// filter hidden files out
+		if (matches[i][0] == '.') {
+			continue;
+		}
+		if (strlen(path)) {
+			Com_sprintf(m, sizeof(m), "%s/%s", path, matches[i]);
+			nlist = FS_AddFileToList(m, list, nlist);
+			continue;
+		}
+		nlist = FS_AddFileToList(matches[i], list, nlist);
+	}
+	FS_FreeFileList(matches);
+
+	// .dm_67
+	matches = FS_ListFilteredFiles(searchpath, ".dm_67", NULL, &n);
+	for (i=0; i<n; i++) {
+		// filter hidden files out
+		if (matches[i][0] == '.') {
+			continue;
+		}
+		if (strlen(path)) {
+			Com_sprintf(m, sizeof(m), "%s/%s", path, matches[i]);
+			nlist = FS_AddFileToList(m, list, nlist);
+			continue;
+		}
+		nlist = FS_AddFileToList(matches[i], list, nlist);
+	}
+	FS_FreeFileList(matches);
+
+	// .dm_66
+	matches = FS_ListFilteredFiles(searchpath, ".dm_66", NULL, &n);
 	for (i=0; i<n; i++) {
 		// filter hidden files out
 		if (matches[i][0] == '.') {
@@ -2627,7 +2660,8 @@
 FS_idPak
 ================
 */
-qboolean FS_idPak( char *pak, char *base ) {
+// Cgg - added const qualifier
+qboolean FS_idPak( const char *pak, const char *base ) {
 	int i;
 
 	for (i = 0; i < NUM_ID_PAKS; i++) {
@@ -2853,7 +2887,7 @@
 		homePath = fs_basepath->string;
 	}
 	fs_homepath = Cvar_Get ("fs_homepath", homePath, CVAR_INIT );
-	fs_gamedirvar = Cvar_Get ("fs_game", "", CVAR_INIT|CVAR_SYSTEMINFO );
+	fs_gamedirvar = Cvar_Get ("fs_game", "defrag", CVAR_INIT|CVAR_SYSTEMINFO );
 	fs_restrict = Cvar_Get ("fs_restrict", "", CVAR_INIT );
 
 	// add search path elements in reverse priority order
@@ -2911,8 +2945,10 @@
 	// reorder the pure pk3 files according to server order
 	FS_ReorderPurePaks();
 	
+// Cgg - gets spammy pretty quickly
 	// print the current search paths
-	FS_Path_f();
+//	FS_Path_f();
+// !Cgg
 
 	fs_gamedirvar->modified = qfalse; // We just loaded, it's not modified
 
@@ -3517,3 +3553,54 @@
 	fflush(fsh[f].handleFiles.file.o);
 }
 
+// Cgg
+// return the current gamedir (eg. "baseq3", "mymod", ...)
+const char *FS_GetGameDir() {
+	return fs_gamedir;
+}
+
+// remove a file from the homepath (eg. C:\quake3\; ~/.q3a/).
+qboolean FS_SV_RemoveFile(const char *qpath) {
+	char stripped[MAX_OSPATH];
+	char *ospath;
+	const char *c;
+	char *ext;
+
+	// make sure the given path doesn't try to climb up the file hierarchy.
+	if (strstr(qpath, "..") || strstr(qpath, "::")) {
+		Com_Printf("Warning: attempted to remove file with invalid path.\n");
+		return qfalse;
+	}
+	// prevent files in base directory from being removed - only files in subdirs can be.
+	for (c=qpath; *c == '/' || *c == '\\'; c++)
+		;
+	if (!strchr(c, '/') && !strchr(c, '\\')) {
+		Com_Printf("Warning: attempted to remove file from base directory.\n");
+		return qfalse;
+	}
+	// prevent id's packs from being removed.
+	// FS_idPak() takes a path without the pk3 extension.
+	Q_strncpyz(stripped, qpath, sizeof(stripped));
+	ext = stripped + strlen(stripped) -4;
+	if (ext > stripped && !strcmp(ext, ".pk3")) {
+		*ext = 0;
+		if (FS_idPak(stripped, "baseq3") || FS_idPak(stripped, "missionpack")) {
+			Com_Printf("Warning: attempted to remove Id's game packs.\n");
+			return qfalse;
+		}
+	}
+	// remove
+	ospath = FS_BuildOSPath(fs_homepath->string, qpath, "");
+	ospath[strlen(ospath)-1] = 0;
+	if (!FS_Remove(ospath)) {
+		Com_Printf("Warning: failed to remove file: %s\n", ospath);
+		return qfalse;
+	}
+	return qtrue;
+}
+
+// remove a file from homepath/gamedir (eg. C:\quake3\mymod\; ~/.q3a/mymod)
+qboolean FS_RemoveFile(const char *filename) {
+	return FS_SV_RemoveFile(va("%s/%s", fs_gamedir, filename));
+}
+// !Cgg
diff -wrubN quake3_1.32b/code/qcommon/huffman.c dfengine_1.07_src/code/qcommon/huffman.c
--- quake3_1.32b/code/qcommon/huffman.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/qcommon/huffman.c	2009-05-18 13:44:57.000000000 +0200
@@ -268,25 +268,6 @@
 	return (*ch = node->symbol);
 }
 
-/* Get a symbol */
-void Huff_offsetReceive (node_t *node, int *ch, byte *fin, int *offset) {
-	bloc = *offset;
-	while (node && node->symbol == INTERNAL_NODE) {
-		if (get_bit(fin)) {
-			node = node->right;
-		} else {
-			node = node->left;
-		}
-	}
-	if (!node) {
-		*ch = 0;
-		return;
-//		Com_Error(ERR_DROP, "Illegal tree!\n");
-	}
-	*ch = node->symbol;
-	*offset = bloc;
-}
-
 /* Send the prefix code for this node */
 static void send(node_t *node, node_t *child, byte *fout) {
 	if (node->parent) {
@@ -315,12 +296,6 @@
 	}
 }
 
-void Huff_offsetTransmit (huff_t *huff, int ch, byte *fout, int *offset) {
-	bloc = *offset;
-	send(huff->loc[ch], NULL, fout);
-	*offset = bloc;
-}
-
 void Huff_Decompress(msg_t *mbuf, int offset) {
 	int			ch, cch, i, j, size;
 	byte		seq[65536];
@@ -413,25 +388,3 @@
 	mbuf->cursize = (bloc>>3) + offset;
 	Com_Memcpy(mbuf->data+offset, seq, (bloc>>3));
 }
-
-void Huff_Init(huffman_t *huff) {
-
-	Com_Memset(&huff->compressor, 0, sizeof(huff_t));
-	Com_Memset(&huff->decompressor, 0, sizeof(huff_t));
-
-	// Initialize the tree & list with the NYT node 
-	huff->decompressor.tree = huff->decompressor.lhead = huff->decompressor.ltail = huff->decompressor.loc[NYT] = &(huff->decompressor.nodeList[huff->decompressor.blocNode++]);
-	huff->decompressor.tree->symbol = NYT;
-	huff->decompressor.tree->weight = 0;
-	huff->decompressor.lhead->next = huff->decompressor.lhead->prev = NULL;
-	huff->decompressor.tree->parent = huff->decompressor.tree->left = huff->decompressor.tree->right = NULL;
-
-	// Add the NYT (not yet transmitted) node into the tree/list */
-	huff->compressor.tree = huff->compressor.lhead = huff->compressor.loc[NYT] =  &(huff->compressor.nodeList[huff->compressor.blocNode++]);
-	huff->compressor.tree->symbol = NYT;
-	huff->compressor.tree->weight = 0;
-	huff->compressor.lhead->next = huff->compressor.lhead->prev = NULL;
-	huff->compressor.tree->parent = huff->compressor.tree->left = huff->compressor.tree->right = NULL;
-	huff->compressor.loc[NYT] = huff->compressor.tree;
-}
-
diff -wrubN quake3_1.32b/code/qcommon/huffman_static.c dfengine_1.07_src/code/qcommon/huffman_static.c
--- quake3_1.32b/code/qcommon/huffman_static.c	1970-01-01 01:00:00.000000000 +0100
+++ dfengine_1.07_src/code/qcommon/huffman_static.c	2009-05-18 14:31:25.000000000 +0200
@@ -0,0 +1,347 @@
+/*
+===========================================================================
+Copyright (C) 2009 Cyril Gantin
+
+This file is part of Quake III Arena source code.
+
+Quake III Arena source code is free software; you can redistribute it
+and/or modify it under the terms of the GNU General Public License as
+published by the Free Software Foundation; either version 2 of the License,
+or (at your option) any later version.
+
+Quake III Arena source code is distributed in the hope that it will be
+useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with Foobar; if not, write to the Free Software
+Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+===========================================================================
+
+Quake 3 uses a prerendered huffman tree to compress netchan messages.
+
+This version is more efficient - eats up less memory, initializes faster - because it uses
+a static code instead of feeding the adaptative huffman algorithm with predefined values.
+
+*/
+
+#include "../game/q_shared.h"
+#include "qcommon.h"
+
+typedef struct {
+	int code:16;
+	int nbits:16;
+} huff_code_t;
+
+static huff_code_t huff_q3code[] = {
+	{ 0x002, 2 },		// 0
+	{ 0x01b, 5 },		// 1
+	{ 0x048, 7 },		// 2
+	{ 0x06c, 7 },		// 3
+	{ 0x0a1, 8 },		// 4
+	{ 0x011, 8 },		// 5
+	{ 0x010, 7 },		// 6
+	{ 0x03f, 6 },		// 7
+	{ 0x015, 5 },		// 8
+	{ 0x034, 7 },		// 9
+	{ 0x069, 7 },		// 10
+	{ 0x00b, 7 },		// 11
+	{ 0x013, 7 },		// 12
+	{ 0x02d, 6 },		// 13
+	{ 0x039, 8 },		// 14
+	{ 0x0ac, 9 },		// 15
+	{ 0x025, 7 },		// 16
+	{ 0x058, 9 },		// 17
+	{ 0x1f0, 9 },		// 18
+	{ 0x1f8, 9 },		// 19
+	{ 0x1dd, 10 },		// 20
+	{ 0x3f3, 10 },		// 21
+	{ 0x22b, 10 },		// 22
+	{ 0x323, 10 },		// 23
+	{ 0x0f4, 9 },		// 24
+	{ 0x18d, 10 },		// 25
+	{ 0x0ab, 10 },		// 26
+	{ 0x363, 10 },		// 27
+	{ 0x1eb, 10 },		// 28
+	{ 0x043, 8 },		// 29
+	{ 0x04f, 9 },		// 30
+	{ 0x0d4, 8 },		// 31
+	{ 0x037, 6 },		// 32
+	{ 0x0d3, 10 },		// 33
+	{ 0x044, 9 },		// 34
+	{ 0x2cd, 10 },		// 35
+	{ 0x3c5, 10 },		// 36
+	{ 0x3f9, 10 },		// 37
+	{ 0x30d, 10 },		// 38
+	{ 0x3cd, 10 },		// 39
+	{ 0x094, 9 },		// 40
+	{ 0x1ac, 10 },		// 41
+	{ 0x033, 10 },		// 42
+	{ 0x014, 10 },		// 43
+	{ 0x271, 10 },		// 44
+	{ 0x2f0, 10 },		// 45
+	{ 0x1f4, 9 },		// 46
+	{ 0x078, 8 },		// 47
+	{ 0x027, 7 },		// 48
+	{ 0x0c3, 8 },		// 49
+	{ 0x0ef, 8 },		// 50
+	{ 0x197, 9 },		// 51
+	{ 0x053, 8 },		// 52
+	{ 0x0b1, 8 },		// 53
+	{ 0x00d, 9 },		// 54
+	{ 0x161, 9 },		// 55
+	{ 0x007, 9 },		// 56
+	{ 0x0f1, 9 },		// 57
+	{ 0x199, 9 },		// 58
+	{ 0x191, 10 },		// 59
+	{ 0x123, 10 },		// 60
+	{ 0x0bc, 9 },		// 61
+	{ 0x144, 9 },		// 62
+	{ 0x1f3, 10 },		// 63
+	{ 0x0cf, 8 },		// 64
+	{ 0x050, 7 },		// 65
+	{ 0x07c, 7 },		// 66
+	{ 0x004, 7 },		// 67
+	{ 0x021, 8 },		// 68
+	{ 0x051, 8 },		// 69
+	{ 0x080, 9 },		// 70
+	{ 0x070, 9 },		// 71
+	{ 0x13d, 9 },		// 72
+	{ 0x063, 10 },		// 73
+	{ 0x2d7, 10 },		// 74
+	{ 0x371, 10 },		// 75
+	{ 0x19d, 9 },		// 76
+	{ 0x2ab, 10 },		// 77
+	{ 0x1c7, 10 },		// 78
+	{ 0x333, 10 },		// 79
+	{ 0x12c, 9 },		// 80
+	{ 0x09d, 10 },		// 81
+	{ 0x16b, 10 },		// 82
+	{ 0x36b, 10 },		// 83
+	{ 0x1d3, 10 },		// 84
+	{ 0x171, 10 },		// 85
+	{ 0x1e3, 10 },		// 86
+	{ 0x233, 10 },		// 87
+	{ 0x0d7, 10 },		// 88
+	{ 0x2cb, 10 },		// 89
+	{ 0x170, 9 },		// 90
+	{ 0x0a8, 9 },		// 91
+	{ 0x0c7, 9 },		// 92
+	{ 0x105, 9 },		// 93
+	{ 0x0eb, 9 },		// 94
+	{ 0x0d8, 8 },		// 95
+	{ 0x0f3, 9 },		// 96
+	{ 0x03c, 8 },		// 97
+	{ 0x1ab, 9 },		// 98
+	{ 0x18f, 9 },		// 99
+	{ 0x097, 9 },		// 100
+	{ 0x030, 7 },		// 101
+	{ 0x041, 8 },		// 102
+	{ 0x14f, 9 },		// 103
+	{ 0x01c, 6 },		// 104
+	{ 0x028, 8 },		// 105
+	{ 0x0bd, 9 },		// 106
+	{ 0x0c4, 9 },		// 107
+	{ 0x098, 8 },		// 108
+	{ 0x08f, 9 },		// 109
+	{ 0x00c, 8 },		// 110
+	{ 0x0b3, 8 },		// 111
+	{ 0x085, 8 },		// 112
+	{ 0x08c, 8 },		// 113
+	{ 0x047, 8 },		// 114
+	{ 0x079, 8 },		// 115
+	{ 0x059, 7 },		// 116
+	{ 0x040, 7 },		// 117
+	{ 0x017, 8 },		// 118
+	{ 0x019, 8 },		// 119
+	{ 0x04b, 8 },		// 120
+	{ 0x0e1, 8 },		// 121
+	{ 0x0a3, 8 },		// 122
+	{ 0x073, 8 },		// 123
+	{ 0x06f, 8 },		// 124
+	{ 0x068, 7 },		// 125
+	{ 0x008, 7 },		// 126
+	{ 0x065, 7 },		// 127
+	{ 0x01f, 6 },		// 128
+	{ 0x029, 7 },		// 129
+	{ 0x04c, 7 },		// 130
+	{ 0x07d, 7 },		// 131
+	{ 0x00f, 8 },		// 132
+	{ 0x083, 8 },		// 133
+	{ 0x001, 8 },		// 134
+	{ 0x087, 8 },		// 135
+	{ 0x067, 8 },		// 136
+	{ 0x0e7, 8 },		// 137
+	{ 0x057, 8 },		// 138
+	{ 0x074, 8 },		// 139
+	{ 0x1cb, 9 },		// 140
+	{ 0x1c4, 9 },		// 141
+	{ 0x081, 9 },		// 142
+	{ 0x04d, 9 },		// 143
+	{ 0x131, 9 },		// 144
+	{ 0x163, 10 },		// 145
+	{ 0x180, 9 },		// 146
+	{ 0x3d7, 10 },		// 147
+	{ 0x02b, 10 },		// 148
+	{ 0x145, 10 },		// 149
+	{ 0x06b, 10 },		// 150
+	{ 0x03d, 10 },		// 151
+	{ 0x32b, 10 },		// 152
+	{ 0x0f9, 10 },		// 153
+	{ 0x0e3, 10 },		// 154
+	{ 0x245, 10 },		// 155
+	{ 0x12b, 10 },		// 156
+	{ 0x031, 10 },		// 157
+	{ 0x3eb, 10 },		// 158
+	{ 0x1b9, 10 },		// 159
+	{ 0x114, 9 },		// 160
+	{ 0x1f9, 10 },		// 161
+	{ 0x133, 10 },		// 162
+	{ 0x02c, 10 },		// 163
+	{ 0x2dd, 10 },		// 164
+	{ 0x1c1, 10 },		// 165
+	{ 0x31d, 10 },		// 166
+	{ 0x1d1, 10 },		// 167
+	{ 0x138, 9 },		// 168
+	{ 0x061, 10 },		// 169
+	{ 0x2e3, 10 },		// 170
+	{ 0x345, 10 },		// 171
+	{ 0x26b, 10 },		// 172
+	{ 0x0cd, 10 },		// 173
+	{ 0x0cb, 10 },		// 174
+	{ 0x14d, 10 },		// 175
+	{ 0x038, 9 },		// 176
+	{ 0x3c1, 10 },		// 177
+	{ 0x23d, 10 },		// 178
+	{ 0x3bc, 10 },		// 179
+	{ 0x0c5, 10 },		// 180
+	{ 0x3ac, 10 },		// 181
+	{ 0x3e3, 10 },		// 182
+	{ 0x299, 10 },		// 183
+	{ 0x3d3, 10 },		// 184
+	{ 0x214, 10 },		// 185
+	{ 0x203, 10 },		// 186
+	{ 0x1bc, 10 },		// 187
+	{ 0x29d, 10 },		// 188
+	{ 0x381, 10 },		// 189
+	{ 0x263, 10 },		// 190
+	{ 0x08d, 10 },		// 191
+	{ 0x054, 8 },		// 192
+	{ 0x103, 9 },		// 193
+	{ 0x05d, 8 },		// 194
+	{ 0x020, 6 },		// 195
+	{ 0x009, 7 },		// 196
+	{ 0x3c7, 10 },		// 197
+	{ 0x307, 10 },		// 198
+	{ 0x0b8, 8 },		// 199
+	{ 0x1f1, 9 },		// 200
+	{ 0x22c, 10 },		// 201
+	{ 0x045, 10 },		// 202
+	{ 0x003, 10 },		// 203
+	{ 0x11d, 10 },		// 204
+	{ 0x1c5, 10 },		// 205
+	{ 0x34d, 10 },		// 206
+	{ 0x01d, 10 },		// 207
+	{ 0x000, 9 },		// 208
+	{ 0x3b9, 10 },		// 209
+	{ 0x0dd, 10 },		// 210
+	{ 0x181, 10 },		// 211
+	{ 0x10d, 10 },		// 212
+	{ 0x0b9, 10 },		// 213
+	{ 0x1cd, 10 },		// 214
+	{ 0x394, 10 },		// 215
+	{ 0x1bd, 10 },		// 216
+	{ 0x194, 10 },		// 217
+	{ 0x38d, 10 },		// 218
+	{ 0x158, 10 },		// 219
+	{ 0x3bd, 10 },		// 220
+	{ 0x0c1, 10 },		// 221
+	{ 0x3dd, 10 },		// 222
+	{ 0x0f8, 10 },		// 223
+	{ 0x0d1, 9 },		// 224
+	{ 0x091, 9 },		// 225
+	{ 0x099, 10 },		// 226
+	{ 0x2f8, 10 },		// 227
+	{ 0x023, 10 },		// 228
+	{ 0x071, 10 },		// 229
+	{ 0x2d3, 10 },		// 230
+	{ 0x391, 10 },		// 231
+	{ 0x049, 7 },		// 232
+	{ 0x231, 10 },		// 233
+	{ 0x107, 10 },		// 234
+	{ 0x261, 10 },		// 235
+	{ 0x223, 10 },		// 236
+	{ 0x018, 8 },		// 237
+	{ 0x205, 10 },		// 238
+	{ 0x2c1, 10 },		// 239
+	{ 0x1d7, 10 },		// 240
+	{ 0x0f0, 10 },		// 241
+	{ 0x2c5, 10 },		// 242
+	{ 0x300, 10 },		// 243
+	{ 0x3d1, 10 },		// 244
+	{ 0x3a8, 10 },		// 245
+	{ 0x21d, 10 },		// 246
+	{ 0x500, 11 },		// 247
+	{ 0x005, 10 },		// 248
+	{ 0x358, 10 },		// 249
+	{ 0x2f9, 10 },		// 250
+	{ 0x1a8, 10 },		// 251
+	{ 0x2b9, 10 },		// 252
+	{ 0x28d, 10 },		// 253
+	{ 0x02f, 7 },		// 254
+	{ 0x024, 6 }		// 255
+};
+
+// adapted from huffman.c
+static void add_bit(char bit, byte *fout, int *offset) {
+	if ((*offset&7) == 0) {
+		fout[(*offset>>3)] = 0;
+	}
+	fout[(*offset>>3)] |= bit << (*offset&7);
+	(*offset)++;
+}
+
+// adapted from huffman.c
+static int get_bit(byte *fin, int *offset) {
+	int t;
+	t = (fin[(*offset>>3)] >> (*offset&7)) & 0x1;
+	(*offset)++;
+	return t;
+}
+
+static int getSymbolForCode(huff_code_t c) {
+	int i;
+	for (i=0; i<256; i++) {
+		if (huff_q3code[i].nbits == c.nbits && huff_q3code[i].code == c.code) {
+			return i;
+		}
+	}
+	return -1;
+}
+void Huff_offsetReceive(int *ch, byte *fin, int *offset) {
+	huff_code_t c;
+	memset(&c, 0, sizeof(c));
+	c.code |= get_bit(fin, offset) << c.nbits++;
+	c.code |= get_bit(fin, offset) << c.nbits++;
+	while ((*ch = getSymbolForCode(c)) == -1) {
+		c.code |= get_bit(fin, offset) << c.nbits++;
+		if (c.nbits	> 11) {
+			*ch = 0;
+			return;	/* code depth reached */
+		}
+	}
+}
+
+void Huff_offsetTransmit(int ch, byte *fout, int *offset) {
+	const huff_code_t *c;
+	int i;
+
+	if (ch < 0 || ch > 255) {
+		Com_Error(ERR_FATAL, "Huffman compression: invalid symbol 0x%x.", ch);
+	}
+	c = huff_q3code+ch;
+	for (i= 0; i<c->nbits; i++) {
+		add_bit((c->code>>i) &1, fout, offset);
+	}
+}
